<?php
/**
 * @brief shortURL, a plugin for Dotclear 2
 *
 * @package Dotclear
 * @subpackage Plugins
 *
 * @author julien mudry and contributors
 *
 * @copyright julien mudry
 * @copyright GPL-2.0 https://www.gnu.org/licenses/gpl-2.0.html
 */
if (!defined('DC_RC_PATH')) { return; }

$this->registerModule(
    "shortURL",
    "Provides a short URL for posts and comments",
    "julien mudry",
    '0.7.1',
    [
        'requires'    => [['core', '2.24']],
        'permissions' => dcCore::app()->auth->makePermissions([
            dcAuth::PERMISSION_USAGE,
            dcAuth::PERMISSION_CONTENT_ADMIN,
        ]),
        'type'        => 'plugin',
        'settings'    => [
            'blog'    => '#params.shortURL',
        ],
        'priority'    => 10000,
        'details'     => 'https://mudry.org/blog/alias/shortURL',
        'support'     => 'https://codeberg.org/julmud/dc2-shortURL',
    ]
);
