<?php
if (!defined('DC_RC_PATH')) { return; }

dcCore::app()->tpl->addValue('EntryShortURL', ['tplShortURL', 'EntryShortURL']);
dcCore::app()->tpl->addValue('CommentShortURL', ['tplShortURL', 'CommentShortURL']);

dcCore::app()->addBehavior('publicHeadContent', ['tplShortUrl', 'publicHeadContent']);

class tplShortURL
{
    public static function EntryShortURL($attr)
    {
        $f = dcCore::app()->tpl->getFilters($attr);
        if (dcCore::app()->blog->settings->shortURL->shortURLEnabled) {
            if (dcCore::app()->blog->settings->shortURL->shortURLEvenShorter) {
                $id = 'dcShortURL::idConversion(dcCore::app()->ctx->posts->post_id)';
            } else {
                $id = 'dcCore::app()->ctx->posts->post_id';
            }
            return '<?php echo '.sprintf($f,'dcCore::app()->blog->url.dcCore::app()->url->getBase("shortURL").'.
                '"/".rawurlencode('.$id.')').'; ?>';
        }
        return '';
    }

    public static function CommentShortURL($attr)
    {
        $f = dcCore::app()->tpl->getFilters($attr);
        if (dcCore::app()->blog->settings->shortURL->shortURLEnabled) {
            if (dcCore::app()->blog->settings->shortURL->shortURLEvenShorter) {
                $id = 'dcShortURL::idConversion(dcCore::app()->ctx->comments->comment_id)';
            } else {
                $id = 'dcCore::app()->ctx->comments->comment_id';
            }
            return '<?php echo '.sprintf($f,'dcCore::app()->blog->url.dcCore::app()->url->getBase("shortURLComment").'.
                '"/".rawurlencode('.$id.')').'; ?>';
        }
        return '';
    }

    public static function publicHeadContent() {
#myLog::log('context: '.dcCore::app()->url->type);
        if (dcCore::app()->blog->settings->shortURL->shortURLEnabled) {
            foreach (dcCore::app()->getPostTypes() as $k => $v) {
                # Construct the base URL for every post type
                $baseURL[preg_replace('/\/%s/','',$v['public_url'])] = $k;
            }
#myLog::log('baseURLs: '.print_r($baseURL, true));
            foreach (dcCore::app()->url->getTypes() as $k => $v) {
                if (array_key_exists($v['url'], $baseURL)) {
                    # We found the context for one of the post type given its base URL
                    $context[$k] = $baseURL[$v['url']];
                }
            }
#myLog::log('contexts: '.print_r($context, true));
            if (array_key_exists(dcCore::app()->url->type, $context)) {
#myLog::log('adding shortlink header in post of type '.$context[dcCore::app()->url->type]);
                if (dcCore::app()->blog->settings->shortURL->shortURLEvenShorter) {
                    $id = dcShortURL::idConversion(dcCore::app()->ctx->posts->post_id);
                } else {
                    $id = dcCore::app()->ctx->posts->post_id;
                }
                $url = dcCore::app()->blog->url.dcCore::app()->url->getBase("shortURL").'/'.rawurlencode($id);
                echo '<link rel="shortlink" type="text/html" href="'.$url.'" />';
            }
        }
    }
}

class shortURL extends dcUrlHandlers
{
    public static function postById($args)
    {
        $id = $args;
        if (!preg_match('/^\d+$/', $id)) {
            if ($id[0] == 'h') {
                $id = substr($id, 1);
            }
            $id = baseConversion::fromBase($id);
        }
        $params = array('no_content' => 1,
            'post_id' => $id,
            'post_type' => '');
        $password = dcCore::app()->blog->without_password;
        dcCore::app()->blog->withoutPassword(false);

        // Try to find the post
        $result = dcCore::app()->blog->getPosts($params);
        dcCore::app()->blog->withoutPassword($password);
        if (!$result || $result->post_type === null) {
            self::p404();
            return;
        }

        // Try to find the URL to go with it
        $base = dcCore::app()->url->getBase($result->post_type);
        if ($base === null) {
            // try an alternate via the plural of the post_type. Works for pages.
            $base = dcCore::app()->url->getBase($result->post_type.'s');
        }
        if ($base === null) {
            // could not find any suitable URL for this post-type
            self::p404();
            return;
        }

        $url = dcCore::app()->blog->url.$base.'/'.$result->post_url;
        http::head(301, 'Moved Permanently');
        header('Location: '.$url);
        return;
    }

    public static function postByCommentId($args)
    {
        $id = $args;
        if (!preg_match('/^\d+$/', $id)) {
            if ($id[0] == 'h') {
                $id = substr($id, 1);
            }
            $id = baseConversion::fromBase($id);
        }
        $params = array('no_content' => 1,
            'comment_id' => $id,
            'post_type' => '');
        $password = dcCore::app()->blog->without_password;
        dcCore::app()->blog->withoutPassword(false);

        // Try to find the post
        $result = dcCore::app()->blog->getComments($params);
        dcCore::app()->blog->withoutPassword($password);
        if (!$result || $result->post_type === null) {
            self::p404();
            return;
        }

        // Try to find the URL to go with it
        $base = dcCore::app()->url->getBase($result->post_type);
        if ($base === null) {
            // try an alternate via the plural of the post_type. Works for pages.
            $base = dcCore::app()->url->getBase($result->post_type.'s');
        }
        if ($base === null) {
            // could not find any suitable URL for this post-type
            self::p404();
            return;
        }

        $url = dcCore::app()->blog->url.$base.'/'.$result->post_url.'#c'.$result->comment_id;
        http::head(301, 'Moved Permanently');
        header('Location: '.$url);
    }

}
