<?php

class baseConversion
{

    public static function toBase($num)
    {
        $chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_-';
        $result = '';
        $base = strlen($chars);
        if ($num == 0) {
            $result = '0';
        }
        while ($num != 0) {
            $rem = $num % $base; // Remainder calculation
            $num = intdiv($num - $rem, $base);
            $result = $chars[$rem] . $result;
        }
        return $result;
    }

    public static function fromBase($num)
    {
        $chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_-';
        $base = strlen($chars);
        $len = strlen($num);
        $result = 0;
        for ($i = $len - 1; $i >= 0; $i--) {
            $char = $num[$i]; // Get the last character from the number
            $value = strpos($chars, $char); // Get the decimal value
            if ($value !== FALSE) {
                $result = $result + $value * pow($base, $len - $i - 1);
//                $result = bcadd($result, bcmul($value, bcpow($base, $len - $i - 1)));
            } // We simply ignore chars that are not part of the base chars
        }
        return $result;
    }
}
